//DESCRIPTION:Eine Tabelle mit dem Namen "qrdata" muss vorhanden sein (siehe Snippet). Wenn das Objektformat "QR-code" nicht vorhanden ist, wird es erstellt. Es werden die Daten aus der Tabelle ausgelesen und ein VCARD-QR-Code erstellt. Im Objektformat kann die Position verändert und gespeichert werden
//copyright: SteigArt | Daniel Steiger
//Version: 2.9

#target Indesign

if(app.documents.length == 0){
    alert("Zuerst ein Dokument öffnen, vor dem Start des Scripts");
}
else{
    var dok = app.activeDocument;
    var qrDataExists = false // Variable zur Feststellung, ob das Textfraem gefunden wurde

    // Alle Textramen finden
    for(var i = 0; i<dok.textFrames.length; i++){
        var foundTextFrame = dok.textFrames[i];

        // Prüfen ob der Name des Textframes "qrdata" ist
        if(foundTextFrame.name === "qrdata"){
            qrDataExists = true;
            break;
        }
    }
    
    // Prüfen ob das Texfraem gefunden wurde
    if(!qrDataExists){
        alert("Die Tabelle mit den VCARD-Vorgaben fehlt. Bitte vorhandenes Snippet einfügen");
    }
    else{

        // Die Tabelle im Textframe "qrdata" auswählen
        var tab = dok.textFrames.itemByName("qrdata").tables[0];

        // Variable Objekte
        var alloStyles = dok.objectStyles;
        var oStyleName = "QR-code";
        var oStylesYes = "";
        var qrBegin = "BEGIN:VCARD\nVERSION:3.0";
        var qrEnd = "END:VCARD";
        var qrcontent = "";


        // Durchsuchen der Zelle nach dem gesuchten Inhalt
        for (var i = 0; i < tab.cells.length; i++){
            var cell = tab.cells[i];
            if(cell.isValid){
                if(cell.contents == "Name") qrName = vcardCode();
                if(cell.contents == "Vorname") qrVorname = vcardCode();
                if(cell.contents == "Firma") qrFirma = vcardCode();
                if(cell.contents == "Titel") qrTitel = vcardCode(); // Achtung Verwirrung: Titel wird in VCARD als Berufsbezeichnung verwendet. Der eigentliche Titel steht unter N: 
                if(cell.contents == "Berufsbez.") qrBezeichn = vcardCode();
                if(cell.contents == "Abteilung") qrAbteil = vcardCode();
                if(cell.contents == "Ort G") qrOrtG = vcardCode();
                if(cell.contents == "Adresse G") qrAdrG = vcardCode();
                if(cell.contents == "PLZ G") qrPLZG = vcardCode();
                if(cell.contents == "Land G") qrLandG = vcardCode();
                if(cell.contents == "Adresse P") qrAdrP = vcardCode();
                if(cell.contents == "PLZ P") qrPLZP = vcardCode();
                if(cell.contents == "Ort P") qrOrtP = vcardCode();
                if(cell.contents == "Land P") qrLandP = vcardCode();
                if(cell.contents == "Mail G") qrEmailWork = vcardCode();
                if(cell.contents == "Mail P") qrEmailPriv = vcardCode();
                if(cell.contents == "Zentrale") qrTelMain = vcardCode();
                if(cell.contents == "Direkt") qrTelDirekt = vcardCode();
                if(cell.contents == "Mobile") qrTelMobile = vcardCode();
                if(cell.contents == "Homepage") qrURL = vcardCode();
                if(cell.contents == "Privat") qrTelPrivat = vcardCode();
            } 
            else{
                alert("Keine Tabellenzellen vorhanden.");
            }     
        }

        // QR-Code zusammensetzen
        var codecontent = qrBegin;
        codecontent += "\nN:" + qrName + ";" + qrVorname + ";;" + qrTitel;
        codecontent += "\nFN:"+qrTitel + qrVorname + " " + qrName;
        codecontent += "\nTITLE:" + qrBezeichn; // Achtung Verwirrung: Titel wird in VCARD als Berufsbezeichnung verwendet. Der eigentliche Titel steht unter N:
        codecontent += "\nORG:" + qrFirma + ";" + qrAbteil;
        if(qrOrtG != ""){
            codecontent += "\nADR;TYPE=work:" + ";;" + qrAdrG + ";" + qrOrtG + ";;" + qrPLZG + ";" + qrLandG;
        }
        if(qrOrtP != ""){
            codecontent += "\nADR;TYPE=home:" + ";;" + qrAdrP + ";" + qrOrtP + ";;" + qrPLZP + ";" + qrLandP;
        }
        codecontent += "\nTEL;TYPE=main:" + qrTelMain;
        codecontent += "\nTEL;TYPE=work:" + qrTelDirekt;
        codecontent += "\nTEL;TYPE=cell:" + qrTelMobile;
        codecontent += "\nTEL;TYPE=home:" + qrTelPrivat;
        codecontent += "\nEMAIL;TYPE=work:" + qrEmailWork;
        codecontent += "\nEMAIL;TYPE=home:" + qrEmailPriv;
        codecontent += "\nURL:" + qrURL;
        codecontent += "\n" + qrEnd;

        // Den eigentlichen QR-Code erstellen
        // qrcode(codecontent);
        qrCodeExists(codecontent);
    }
}

function vcardCode(){
                // Auswahl der gefundenen Zelle
                var foundIndex = cell.index;
                var nextIndex = parseInt(foundIndex) + 1;
                var nextCell = tab.cells[nextIndex];
                var qrcontent = tab.cells.item(nextIndex).contents;
                return qrcontent;
}

function qrCodeExists(codecontent){
    var qrCodeRectangleExist = false;

    // Durchlaufe alle Rechtecke im Dokument
    for (r = 0; r < dok.rectangles.length; r++){
        var qrFrame = dok.rectangles[r];
        if (qrFrame.name === "VCARD-QRcode"){
            qrCodeRectangleExist = true;
        }
    }

    // Wenn existiert, dann löschen und neu aufbauen
    if(qrCodeRectangleExist){
        qrFrame.remove();
        qrcode(codecontent);
    }
    else{
        qrcode(codecontent);
    }

}


function qrcode(codecontent){
    //Prüfen ob Objektformat vorhanden
    for (var i = 0; i < alloStyles.length; i++){
        if(alloStyles[i].name === oStyleName){
            oStylesYes = "vorhanden"; //Setze Variable auf "vorhanden"
        }
    }

    if(oStylesYes != "vorhanden"){
        var newObjectStyle = dok.objectStyles.add();
        newObjectStyle.name = oStyleName;
        var qrObjectStyle = dok.objectStyles.itemByName("QR-code");
        qrObjectStyle.strokeWeight = 0;
        qrObjectStyle.enableTransformAttributes = true;
        qrObjectStyle.transformAttributeOptions.transformAttrRefAnchorPoint = AnchorPoint.TOP_LEFT_ANCHOR;
        qrObjectStyle.transformAttributeOptions.transformAttrHeight = 30;
        qrObjectStyle.transformAttributeOptions.transformAttrWidth = 30;
        qrObjectStyle.transformAttributeOptions.transformAttrX = 10;
        qrObjectStyle.transformAttributeOptions.transformAttrY = 10;
        // qrObjectStyle.strokeTint = 50;
        alert('Es wurde ein Objektformat "QR-code" hinzugefügt. Darin kann die Position des QR-Codes definiert werden');
    }
    // Aktive Seite auslesen und in Variable speichern
    var qrseite = app.activeWindow.activePage.documentOffset;
    
    // Bildbox oberhalb der Textbox erstellen (Object Rectangle)
    var QRsel = dok.pages[qrseite].rectangles.add(); // Bildbox erstellen

    // QR-Code erstellen mit ausgewähltem Inhalt befüllen
    QRsel.createPlainTextQRCode (codecontent); 

    // QR-Code Objektformat zuweisen
    QRsel.appliedObjectStyle = dok.objectStyles.itemByName(oStyleName);
    QRsel.name = "VCARD-QRcode";
}